'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _bunyan = require('bunyan');

var _bunyan2 = _interopRequireDefault(_bunyan);

var _types = require('../constants/types');

var _fieldOMat = require('./field-o-mat');

var _fieldOMat2 = _interopRequireDefault(_fieldOMat);

var _apiField = require('../prototype/api-field');

var _apiField2 = _interopRequireDefault(_apiField);

var _apiFieldDynamic = require('../prototype/api-field-dynamic');

var _apiFieldDynamic2 = _interopRequireDefault(_apiFieldDynamic);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var log = _bunyan2.default.createLogger({ name: "ApiFieldOMat" });

/**
 * This will allow a pre-determined type of field to
 * be added at different points in the API as determined
 * by the using author.
 */
var ApiFieldOMat = function () {
  function ApiFieldOMat(parent, key) {
    var params = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _types.NONE;

    _classCallCheck(this, ApiFieldOMat);

    this.TYPE = _types.API_FIELD_O_MAT;

    this._params = {
      parent: parent,
      key: key,
      dynamic: false,
      fieldOMat: new _fieldOMat2.default().init(parent, key)
    };
  }

  _createClass(ApiFieldOMat, [{
    key: '$',
    value: function $() {
      return this._params.parent;
    }
  }, {
    key: 'default',
    value: function _default() {
      var _default2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _types.NONE;

      if (_default2 === _types.NONE) return this._params.fieldOMat._default();

      return this._params.fieldOMat.default(_default2);
    }
  }, {
    key: 'field',
    value: function field() {
      return this._params.fieldOMat;
    }
  }, {
    key: 'dynamic',
    value: function dynamic() {
      this._params.dynamic = true;
      return this;
    }
  }, {
    key: 'key',
    value: function key() {
      return this._params.key;
    }
  }, {
    key: 'addToClassMixins',
    value: function addToClassMixins(mixins) {
      var paramObjectKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '_params';
      var _params = this._params,
          key = _params.key,
          dynamic = _params.dynamic,
          fieldOMat = _params.fieldOMat;

      var BaseField = dynamic === true ? _apiFieldDynamic2.default : _apiField2.default;

      var ApiField = function (_BaseField) {
        _inherits(ApiField, _BaseField);

        function ApiField() {
          _classCallCheck(this, ApiField);

          return _possibleConstructorReturn(this, (ApiField.__proto__ || Object.getPrototypeOf(ApiField)).apply(this, arguments));
        }

        return ApiField;
      }(BaseField);

      mixins[key] = function (key) {
        return new ApiField(this, fieldOMat, paramObjectKey, key);
      };
      return mixins;
    }
  }]);

  return ApiFieldOMat;
}();

exports.default = ApiFieldOMat;
//# sourceMappingURL=api-field-o-mat.js.map