'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _bunyan = require('bunyan');

var _bunyan2 = _interopRequireDefault(_bunyan);

var _types = require('../constants/types');

var _buildField = require('../methods/build-field');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var log = _bunyan2.default.createLogger({ name: "ApiField" });

var ApiField = function () {
  function ApiField(parent, fieldOMat, paramObjectKey, key) {
    _classCallCheck(this, ApiField);

    this.TYPE = _types.API_FIELD;

    this._params = {
      key: key,
      parent: parent,
      fieldOMat: fieldOMat,
      paramObjectKey: paramObjectKey,

      apiKey: _types.NONE,
      value: _types.NONE,
      _default: _types.NONE
    };
  }

  _createClass(ApiField, [{
    key: '$',
    value: function $() {
      var _params = this._params,
          apiKey = _params.apiKey,
          _default = _params._default,
          fieldOMat = _params.fieldOMat,
          parent = _params.parent,
          paramObjectKey = _params.paramObjectKey;

      var parentFields = parent.___fields;
      if (apiKey === _types.NONE) throw new Error('Missing ApiField Name');

      if (typeof parent.apiKey !== 'undefined' && force === false) {
        throw new Error('Cannot overwrite api apiKey: ' + apiKey);
      }
      var newFieldOMat = fieldOMat.again().key(apiKey);
      newFieldOMat.internalKey(apiKey);
      var fieldDefault = (0, _buildField.adjustDefault)(newFieldOMat.params());

      var fieldMethod = (0, _buildField.build)(_extends({}, newFieldOMat.params(), { paramObjectKey: paramObjectKey }));
      parent.___fields.push(apiKey);
      parent[apiKey] = fieldMethod;
    }
  }, {
    key: 'key',
    value: function key() {
      return this._params.key;
    }
  }, {
    key: 'as',
    value: function as(apiKey) {
      this._params.apiKey = apiKey;
      return this;
    }
  }, {
    key: 'as$',
    value: function as$(apiKey) {
      return this.as(apiKey).$();
    }
  }, {
    key: '_default',
    value: function _default(value) {
      this._params._default = value;
      return this;
    }
  }, {
    key: 'force',
    value: function force(doForce) {
      this._params.force = true;
      return this;
    }
  }]);

  return ApiField;
}();

exports.default = ApiField;
//# sourceMappingURL=api-field.js.map