

import Bunyan from 'bunyan';
const  log = Bunyan.createLogger({name: "FieldCopier"});


import { NONE, COPY } from '../constants/types';

/**
 * manages parameters for copying a field to the next 
 * ClassOMat
 */
class FieldCopier { 
  
  TYPE = COPY;

  constructor(parent, key=NONE) { 
    this._params = { 
      key,
      parent,
      as: key
    }
  }

  $() { 
    return this._params.parent._addCopiedField(this);
  }

  as(as=NONE) { 
    if (as === NONE) return this._params.as;

    this._params.as = as;
    return this;
  }

  as$(as=NONE) { 
    return this.as(as).$();
  }

  copyField(key) { 
    return this.$().copyField(key);
  }

}

export default FieldCopier;
